-- Author: Julien Lange (jl250@le.ac.uk)
-- 2009-2010

-- This module



module Local.MultiTyping (typingSystem) where


import Local.TypingSystem
import Data.Map 
import Common.Absglobaltype
import Global.Projection
import Common.Typing
import qualified Data.Set as Set


--
-- Return the type of a process
-- according to an environment (Sorting, i.e. storing projections)
--
typingSystem :: Sorting -> Process -> Typing
typingSystem sort pr = sessionTypingConc compatible (++) sort pr


--
-- Tries to type without projection
-- (deprecated)
--
localTypingSystem :: Process -> Typing
localTypingSystem p = sessionTypingConc compatible (++) Empty p




--
-- See the definition of compatibility in 
-- "Multiparty Asynchronous Session Types"
--
compatible :: Typing -> Typing -> Bool
compatible ((c1,p1,cs1,lt1):xs) [] = True
compatible []  ((c2,p2,cs2,lt2):ys) = True
compatible [] [] = True
compatible ((c1,p1,cs1,lt1):xs) ((c2,p2,cs2,lt2):ys) = 
    if p1 /= p2 && Set.null (Set.intersection (Set.fromList cs1) (Set.fromList cs2))
    then compatible xs ((c2,p2,cs2,lt2):ys) && compatible ((c1,p1,cs1,lt1):xs) ys
    else cs1 == cs2 && compatible xs ((c2,p2,cs2,lt2):ys) && compatible ((c1,p1,cs1,lt1):xs) ys
